<?php
/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

class SeeMyModelOptions {
	private $seemymodel_options_options;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'seemymodel_options_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'seemymodel_options_page_init' ) );
	}

	public function seemymodel_options_add_plugin_page() {
		add_options_page(
			'SeeMyModel settings', // page_title
			'SeeMyModel settings', // menu_title
			'manage_options', // capability
			'seemymodel-options', // menu_slug
			array( $this, 'seemymodel_options_create_admin_page' ) // function
		);
	}

	public function seemymodel_options_create_admin_page() {
		$this->seemymodel_options_options = get_option( 'seemymodel_options_option_name' ); ?>

		<div class="wrap">
			<h2>SeeMyModel settings</h2>
			<p></p>
			<?php settings_errors(); ?>

			<form method="post" action="options.php">
				<?php
					settings_fields( 'seemymodel_options_option_group' );
					do_settings_sections( 'seemymodel-options-admin' );
					if ($this->logged_in()) {
						submit_button('Log out');
					} else {
						submit_button('Log in');
					}
					
				?>
			</form>
		</div>
	<?php }

	public function seemymodel_options_page_init() {
		register_setting(
			'seemymodel_options_option_group', // option_group
			'seemymodel_options_option_name', // option_name
			array( $this, 'seemymodel_options_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'seemymodel_options_setting_section', // id
			'Authorization', // title
			array( $this, 'seemymodel_options_section_info' ), // callback
			'seemymodel-options-admin' // page
		);
		if (!$this->logged_in()) {
			add_settings_field(
				'seemymodel_user_email_0', // id
				'SeeMyModel user email', // title
				array( $this, 'seemymodel_user_email_0_callback' ), // callback
				'seemymodel-options-admin', // page
				'seemymodel_options_setting_section' // section
			);
			
			add_settings_field(
				'seemymodel_user_password_1', // id
				'SeeMyModel user password', // title
				array( $this, 'seemymodel_user_password_1_callback' ), // callback
				'seemymodel-options-admin', // page
				'seemymodel_options_setting_section' // section
			);
		}
		
	}

	public function seemymodel_options_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['seemymodel_user_email_0'] ) ) {
			$sanitary_values['seemymodel_user_email_0'] = sanitize_text_field( $input['seemymodel_user_email_0'] );
		}

		if ( isset( $input['seemymodel_user_password_1'] ) ) {
			$pass = sanitize_text_field( $input['seemymodel_user_password_1'] );
			$endpoint = 'https://api.seemymodel.com/auth/login';
 
			$body = [
				
				'email' => $sanitary_values['seemymodel_user_email_0'],
				'password' => $pass
			];
			
			$body = wp_json_encode( $body );
			
			$options = [
				'body'        => $body,
				'headers'     => [
					'Content-Type' => 'application/json',
				],
				'timeout'     => 60,
				'redirection' => 5,
				'blocking'    => true,
				'sslverify'   => true,
				'data_format' => 'body',
			];
			
			$response = wp_remote_post( $endpoint, $options );
			// Response body.
			$body = wp_remote_retrieve_body( $response );

			if ( is_wp_error( $response ) ) {
				$error_message = $response->get_error_message();
				//would be good to indicate error to user but i dont know how yet
				add_settings_error('seemymodel_user_email_0','500', 'Unknown error');
			} else {
				$responceData = json_decode( $body, true );
				$status = wp_remote_retrieve_response_code( $response );
				if ($status == 201)
					$sanitary_values['seemymodel_user_password_1'] = $responceData['accessToken'];
				else if ($status == 401){
					add_settings_error('seemymodel_user_email_0','401', 'Wrong email or password');
				}else {
					add_settings_error('seemymodel_user_email_0','500', 'Unknown error');
				}

			}
			
		}

		return $sanitary_values;
	}

	public function seemymodel_options_section_info() {
		if ($this->logged_in()){
			?>
			<p>
				You are logged into seemymodel.com as user: <?php echo esc_html( $this->seemymodel_options_options['seemymodel_user_email_0']) ?>
			</p>
			<?php
		} else {
			?>
			<p>
				You are not logged into seemymodel.com. Please fill forms below to log in.
			</p>
			<?php
		}
	}

	public function seemymodel_user_email_0_callback() {
		printf(
			'<input class="regular-text" type="text" name="seemymodel_options_option_name[seemymodel_user_email_0]" id="seemymodel_user_email_0" value="%s">',
			isset( $this->seemymodel_options_options['seemymodel_user_email_0'] ) ? esc_attr( $this->seemymodel_options_options['seemymodel_user_email_0']) : ''
		);
	}

	public function seemymodel_user_password_1_callback() {
		printf(
			'<input class="regular-text" type="password" name="seemymodel_options_option_name[seemymodel_user_password_1]" id="seemymodel_user_password_1" value="%s">',
			$this->logged_in() ? '*********' : ''
		);
	}

    public function logged_in() {
        
        $seemymodel_options_options = get_option( 'seemymodel_options_option_name' ); // Array of All Options
        if (!isset($seemymodel_options_options['seemymodel_user_password_1'])) return false;
        $admin_seemymodel_jwt_token = $seemymodel_options_options['seemymodel_user_password_1']; // SeeMyModel user password
			
        $endpoint = 'https://api.seemymodel.com/user-profile';
        $options = [
            'headers'     => [
                'Authorization' => 'Bearer ' . $admin_seemymodel_jwt_token,
            ],
            'timeout'     => 60,
            'redirection' => 5,
            'blocking'    => true,
            'sslverify'   => true,
        ];
        
        $response = wp_remote_get( $endpoint, $options );
		
        if ( is_wp_error( $response ) ) {
            return false;
        } else {
            $status = wp_remote_retrieve_response_code( $response );
            if ($status == 200) return true;
            return false;
        }
       
    }

}

/* 
 * Retrieve this value with:
 * $seemymodel_options_options = get_option( 'seemymodel_options_option_name' ); // Array of All Options
 * $seemymodel_user_email_0 = $seemymodel_options_options['seemymodel_user_email_0']; // SeeMyModel user email
 * $seemymodel_user_password_1 = $seemymodel_options_options['seemymodel_user_password_1']; // SeeMyModel user password
 */